-- Based on original code written by Gordon Tyler

local frameConstructors = {
  SimpleSelectExt        = Library.LibSimpleWidgetsExt.Select,
  SimpleScrollListExt    = Library.LibSimpleWidgetsExt.ScrollList,
  SimpleLayoutExt        = Library.LibSimpleWidgetsExt.Layout,
  SimpleBorderExt        = Library.LibSimpleWidgetsExt.Border,
  SimpleTextureButtonExt = Library.LibSimpleWidgetsExt.TextureButton,
}

local oldUICreateFrame = UI.CreateFrame
UI.CreateFrame = function(type, name, parent, settings)
  local constructor = frameConstructors[type]
  if constructor then
    return constructor(name, parent)
  elseif settings then
    return oldUICreateFrame(type, name, parent, settings)
  else
    return oldUICreateFrame(type, name, parent)
  end
end
